// Mesh3d.h


#ifndef __Mesh3d_h__
#define __Mesh3d_h__

#include "types.h"
#include "Color.h"
#include "Vector.h"
#include "Vertex.h"
#include "Matrix.h"
#include "ObjTable.h"


class Mesh3d {
	int	wid;
	int	hgt;
	Vertex	*point;
	Vertex	*trans;
public:
	Mesh3d(char *fname);
	~Mesh3d();
	void render(Eye &e, Matrix4x4 m, Vector light);
};

#endif

