// ObjTable.C


#include "types.h"
#include "ObjTable.h"


Obj3dTable::~Obj3dTable()
{
Obj3dNode *op = head;
	while(op) {
		Obj3dNode *next = op->next;
		delete op->obj;
		delete op;
		op = next;
	}
}


Obj3d* Obj3dTable::operator[] (int id)
{
Obj3dNode *op = head;
	while(op) {
		if(op->obj->id == id)
			return op->obj;
		op = op->next;
	}
	return 0;
}


void Obj3dTable::insert(Obj3d *o)
{
Obj3dNode *node = new Obj3dNode(o);
	node->next = head;
	if(head)
		head->prev = node;
	head = node;
}


void Obj3dTable::remove(Obj3d *obj)
{
Obj3dNode *op = head;
	while(op) {
		if(op->obj == obj)
			goto found;
		op = op->next;
	}
	return;
found:
	if(op->prev)
		op->prev->next = op->next;	
	else
		head = op->next;
	if(op->next)
		op->next->prev = op->prev;
}

