// Vertex.h

#ifndef __Vertex_h__
#define __Vertex_h__

#include "types.h"
#include "Vector.h"
#include "Color.h"


class Vertex : public Vector, public Color {
public:
	Vertex()			{}
	Vertex(Vector &v)		{ *(Vector*)this = v; }
	Vertex& operator= (Vector &v)	{ *(Vector*)this = v; return *this; }
	Vertex(Color &c)		{ *(Color*)this = c; }
	Vertex& operator= (Color &c)	{ *(Color*)this = c; return *this; }
	Vertex(vec_t x, vec_t y, vec_t z,
		ushort red, ushort green, ushort blue)
			: Vector(x, y, z), Color(red, green, blue) {}
};


#endif

