 
 















 
 
































   void   ViewPort::raw_vline   (
		register int x, int y1, int y2,
 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
  ColorSlope c(c1, c2, dy);
  Slope z(z1, z2, dy);
  ZPixel *zp = &zbuf_y[y][x];

	set_mask(1 << (x&3));
	Pixel *pp = &frame_y[y][x/4];

	while(dy-- >= 0) {
 		if(z < *zp) {
 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
 		}
 		++z;
 		zp += pitch;
		pp += vpitch;
 		++c;
	}
}






   void    ViewPort::raw_hline   (
			register int x, int x2, int y,
			int z, int z2, Color &c, Color &c2)
{
register Pixel *pp = &frame_y[y][x/4];
register ZPixel *zp = &zbuf_y[y][x];
register int max = 0;	
register int pix = 0, oldpix = 0;
Pixel *savepp = 0;
	while(x <= x2) {
		pix = cmap->match(c);
		if(max && (z >= *zp || pix != oldpix)) {
			if(max >= 4) {
				set_mask(0xf);
				asm("movb %%al,%%ah; movw %%ax,%%dx;"
				    "shll $16,%%eax; movw %%dx,%%ax;"
				    "shrl $2,%%ecx; movl %%ecx,%%edx;"
				    "shrl $2,%%ecx; jz 1f;"
				    "rep; stosl;"
				    "1: movl %%edx,%%ecx;"
				    "andl $3,%%ecx; jz 2f;"
				    "rep; stosb;"
				    "2:"  :"=D"(savepp) :
					"a"(oldpix), "c"(max),
					"D"(savepp) :
					"eax", "ecx", "edx");
				max &= 3;
			}
			while(max) {
				set_mask(1<<((x-max)&3));
				*savepp = oldpix;
				max--;
			}
		}
		if(z < *zp) {
			*zp = z;
			if(max)
				max++;
			else if(!(x&0xf)) {
				savepp = pp;
				oldpix = pix;
				max++;
			} else {
				set_mask(1 << (x&3));
				*pp = pix;
			}
		} 
		zp++;
		if(!(++x&3))
			pp++;
	}
	if(max) {
		if(max >= 4) {
			set_mask(0xf);
			asm("movb %%al,%%ah; movw %%ax,%%dx;"
			    "shll $16,%%eax; movw %%dx,%%ax;"
			    "shrl $2,%%ecx; movl %%ecx,%%edx;"
			    "shrl $2,%%ecx; jz 1f;"
			    "rep; stosl;"
			    "1: movl %%edx,%%ecx;"
			    "andl $3,%%ecx; jz 2f;"
			    "rep; stosb;"
			    "2:"  : "=D"(savepp) :
				"a"(oldpix), "c"(max),
				"D"(savepp) :
				"eax", "ecx", "edx");
			max &= 3;
		}
		while(max) {
			set_mask(1<<((x-max)&3));
			*savepp = oldpix;
			max--;
		}
	}
}






   void    ViewPort::raw_line   (
		int x1, int y1,
		int x2, int y2,
 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
 		Slope z(z1, z2, adx);
 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			x += xinc; ++y;
 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
 		Slope z(z1, z2, ady);
 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			++x; y += yinc;
 			++c;
		} while(y != y2);
	} else {
 		ZPixel *zp = &zbuf_y[y1][x1];
 		if(z1 < *zp || z2 < *zp) {
 			if(z1 < z2)
 				*zp = z1;	
 			else
 				*zp = z2;
			set_mask(1 << (x1&3));
 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
 		}
	}	
}



 
 
































   void   ViewPort::raw_vline   (
		register int x, int y1, int y2,
// 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
  ColorSlope c(c1, c2, dy);
//  Slope z(z1, z2, dy);
//  ZPixel *zp = &zbuf_y[y][x];

	set_mask(1 << (x&3));
	Pixel *pp = &frame_y[y][x/4];

	while(dy-- >= 0) {
// 		if(z < *zp) {
// 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
// 		}
// 		++z;
// 		zp += pitch;
		pp += vpitch;
 		++c;
	}
}











   void    ViewPort::raw_line   (
		int x1, int y1,
		int x2, int y2,
// 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
// 		Slope z(z1, z2, adx);
 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			x += xinc; ++y;
 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
// 		Slope z(z1, z2, ady);
 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			++x; y += yinc;
 			++c;
		} while(y != y2);
	} else {
// 		ZPixel *zp = &zbuf_y[y1][x1];
// 		if(z1 < *zp || z2 < *zp) {
// 			if(z1 < z2)
// 				*zp = z1;	
// 			else
// 				*zp = z2;
			set_mask(1 << (x1&3));
 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
// 		}
	}	
}



 
 
































   void   ViewPort::raw_vline   (
		register int x, int y1, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
//  Slope z(z1, z2, dy);
//  ZPixel *zp = &zbuf_y[y][x];

	set_mask(1 << (x&3));
	Pixel *pp = &frame_y[y][x/4];

	while(dy-- >= 0) {
// 		if(z < *zp) {
// 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
// 		}
// 		++z;
// 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line   (
		int x1, int y1,
		int x2, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
// 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
// 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
// 		ZPixel *zp = &zbuf_y[y1][x1];
// 		if(z1 < *zp || z2 < *zp) {
// 			if(z1 < z2)
// 				*zp = z1;	
// 			else
// 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
// 		}
	}	
}



 
 
































   void   ViewPort::raw_vline   (
		register int x, int y1, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
  Slope z(z1, z2, dy);
  ZPixel *zp = &zbuf_y[y][x];

	set_mask(1 << (x&3));
	Pixel *pp = &frame_y[y][x/4];

	while(dy-- >= 0) {
 		if(z < *zp) {
 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
 		}
 		++z;
 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line   (
		int x1, int y1,
		int x2, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
 		ZPixel *zp = &zbuf_y[y1][x1];
 		if(z1 < *zp || z2 < *zp) {
 			if(z1 < z2)
 				*zp = z1;	
 			else
 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
 		}
	}	
}



 
 
































   void   ViewPort::raw_vline   (
		register int x, int y1, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
  Slope z(z1, z2, dy);
  ZPixel *zp = &zbuf_y[y][x];

	set_mask(1 << (x&3));
	Pixel *pp = &frame_y[y][x/4];

	while(dy-- >= 0) {
 		if(z < *zp) {
 			*zp = z;
// 			*pp = cmap->match(c);
 			*pp = pix;
 		}
 		++z;
 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line   (
		int x1, int y1,
		int x2, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

// 					= cmap->match(c);
 					= pix;
 			}
 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

// 					= cmap->match(c);
 					= pix;
 			}
 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
 		ZPixel *zp = &zbuf_y[y1][x1];
 		if(z1 < *zp || z2 < *zp) {
 			if(z1 < z2)
 				*zp = z1;	
 			else
 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
 			frame_y[y1][x1/4] = pix;
 		}
	}	
}



 
 
































   void   ViewPort::raw_vline   (
		register int x, int y1, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
//  Slope z(z1, z2, dy);
//  ZPixel *zp = &zbuf_y[y][x];

	set_mask(1 << (x&3));
	Pixel *pp = &frame_y[y][x/4];

	while(dy-- >= 0) {
// 		if(z < *zp) {
// 			*zp = z;
// 			*pp = cmap->match(c);
 			*pp = pix;
// 		}
// 		++z;
// 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line   (
		int x1, int y1,
		int x2, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
// 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

// 					= cmap->match(c);
 					= pix;
// 			}
// 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
// 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				set_mask(1 << (x&3));
				frame_y[y][x/4]

// 					= cmap->match(c);
 					= pix;
// 			}
// 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
// 		ZPixel *zp = &zbuf_y[y1][x1];
// 		if(z1 < *zp || z2 < *zp) {
// 			if(z1 < z2)
// 				*zp = z1;	
// 			else
// 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
 			frame_y[y1][x1/4] = pix;
// 		}
	}	
}



 
