 
 















 
 
































   void   ViewPort::raw_vline_stereo  (
		register int x, int y1, int y2,
 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
  ColorSlope c(c1, c2, dy);
  Slope z(z1, z2, dy);
  ZPixel *zp = &zbuf_y[y][x];

	Pixel *pp = &frame_y[y][x];

	while(dy-- >= 0) {
 		if(z < *zp) {
 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
 		}
 		++z;
 		zp += pitch;
		pp += vpitch;
 		++c;
	}
}






   void    ViewPort::raw_hline_stereo  (
			register int x, int x2, int y,
			int z1, int z2, Color &c1, Color &c2)
{
register Pixel *pp = &frame_y[y][x/4];
register ZPixel *zp = &zbuf_y[y][x];
int dx = x2-x;
ColorSlope c(c1, c2, dx);
Slope z(z1, z2, dx);
	while(dx-- >= 0) {
		if(z > *zp) {
			*zp = z;
			*pp = cmap->match(c);
		}
		++pp;
		++z;
		++c;
	}
}






   void    ViewPort::raw_line_stereo  (
		int x1, int y1,
		int x2, int y2,
 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
 		Slope z(z1, z2, adx);
 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				frame_y[y][x] 

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			x += xinc; ++y;
 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
 		Slope z(z1, z2, ady);
 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				frame_y[y][x]

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			++x; y += yinc;
 			++c;
		} while(y != y2);
	} else {
 		ZPixel *zp = &zbuf_y[y1][x1];
 		if(z1 < *zp || z2 < *zp) {
 			if(z1 < z2)
 				*zp = z1;	
 			else
 				*zp = z2;
			set_mask(1 << (x1&3));
 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
 		}
	}	
}



 
 
































   void   ViewPort::raw_vline_stereo  (
		register int x, int y1, int y2,
// 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
  ColorSlope c(c1, c2, dy);
//  Slope z(z1, z2, dy);
//  ZPixel *zp = &zbuf_y[y][x];

	Pixel *pp = &frame_y[y][x];

	while(dy-- >= 0) {
// 		if(z < *zp) {
// 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
// 		}
// 		++z;
// 		zp += pitch;
		pp += vpitch;
 		++c;
	}
}











   void    ViewPort::raw_line_stereo  (
		int x1, int y1,
		int x2, int y2,
// 		int z1, int z2,
 		Color &c1, Color &c2
// 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
// 		Slope z(z1, z2, adx);
 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				frame_y[y][x] 

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			x += xinc; ++y;
 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
// 		Slope z(z1, z2, ady);
 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				frame_y[y][x]

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			++x; y += yinc;
 			++c;
		} while(y != y2);
	} else {
// 		ZPixel *zp = &zbuf_y[y1][x1];
// 		if(z1 < *zp || z2 < *zp) {
// 			if(z1 < z2)
// 				*zp = z1;	
// 			else
// 				*zp = z2;
			set_mask(1 << (x1&3));
 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
// 		}
	}	
}



 
 
































   void   ViewPort::raw_vline_stereo  (
		register int x, int y1, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
//  Slope z(z1, z2, dy);
//  ZPixel *zp = &zbuf_y[y][x];

	Pixel *pp = &frame_y[y][x];

	while(dy-- >= 0) {
// 		if(z < *zp) {
// 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
// 		}
// 		++z;
// 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line_stereo  (
		int x1, int y1,
		int x2, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
// 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				frame_y[y][x] 

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
// 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				frame_y[y][x]

 					= cmap->match(c);
// 					= pix;
// 			}
// 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
// 		ZPixel *zp = &zbuf_y[y1][x1];
// 		if(z1 < *zp || z2 < *zp) {
// 			if(z1 < z2)
// 				*zp = z1;	
// 			else
// 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
// 		}
	}	
}



 
 
































   void   ViewPort::raw_vline_stereo  (
		register int x, int y1, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
  Slope z(z1, z2, dy);
  ZPixel *zp = &zbuf_y[y][x];

	Pixel *pp = &frame_y[y][x];

	while(dy-- >= 0) {
 		if(z < *zp) {
 			*zp = z;
 			*pp = cmap->match(c);
// 			*pp = pix;
 		}
 		++z;
 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line_stereo  (
		int x1, int y1,
		int x2, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
 	Color &c
// 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				frame_y[y][x] 

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				frame_y[y][x]

 					= cmap->match(c);
// 					= pix;
 			}
 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
 		ZPixel *zp = &zbuf_y[y1][x1];
 		if(z1 < *zp || z2 < *zp) {
 			if(z1 < z2)
 				*zp = z1;	
 			else
 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
 		frame_y[y1][x1/4] = cmap->match(c);
// 			frame_y[y1][x1/4] = pix;
 		}
	}	
}



 
 
































   void   ViewPort::raw_vline_stereo  (
		register int x, int y1, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
  Slope z(z1, z2, dy);
  ZPixel *zp = &zbuf_y[y][x];

	Pixel *pp = &frame_y[y][x];

	while(dy-- >= 0) {
 		if(z < *zp) {
 			*zp = z;
// 			*pp = cmap->match(c);
 			*pp = pix;
 		}
 		++z;
 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line_stereo  (
		int x1, int y1,
		int x2, int y2,
 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				frame_y[y][x] 

// 					= cmap->match(c);
 					= pix;
 			}
 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
 			ZPixel *zp = &zbuf_y[y][x];
 			if(z < *zp) {
 				*zp = z;

				frame_y[y][x]

// 					= cmap->match(c);
 					= pix;
 			}
 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
 		ZPixel *zp = &zbuf_y[y1][x1];
 		if(z1 < *zp || z2 < *zp) {
 			if(z1 < z2)
 				*zp = z1;	
 			else
 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
 			frame_y[y1][x1/4] = pix;
 		}
	}	
}



 
 
































   void   ViewPort::raw_vline_stereo  (
		register int x, int y1, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
register int y = y1;
int dy = y2-y1;
//  ColorSlope c(c1, c2, dy);
//  Slope z(z1, z2, dy);
//  ZPixel *zp = &zbuf_y[y][x];

	Pixel *pp = &frame_y[y][x];

	while(dy-- >= 0) {
// 		if(z < *zp) {
// 			*zp = z;
// 			*pp = cmap->match(c);
 			*pp = pix;
// 		}
// 		++z;
// 		zp += pitch;
		pp += vpitch;
// 		++c;
	}
}











   void    ViewPort::raw_line_stereo  (
		int x1, int y1,
		int x2, int y2,
// 		int z1, int z2,
// 		Color &c1, Color &c2
// 	Color &c
 		Pixel pix
		)
{
int dy = y2-y1;
int ady = ((( dy ) >= 0) ? ( dy ) : -( dy )) ;
int dx = x2-x1;
int adx = ((( dx ) >= 0) ? ( dx ) : -( dx )) ;
	if(adx > ady) {
		int x = x1;
		Slope y(y1, y2, adx);
// 		Slope z(z1, z2, adx);
// 		ColorSlope c(c1, c2, adx);
		int xinc = ((( dx ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				frame_y[y][x] 

// 					= cmap->match(c);
 					= pix;
// 			}
// 			++z;
			x += xinc; ++y;
// 			++c;
		} while(x != x2);
	} else if(ady) {
		Slope x(x1, x2, ady);
		int y = y1;
// 		Slope z(z1, z2, ady);
// 		ColorSlope c(c1, c2, ady);
		int yinc = ((( dy ) > 0) ? 1 : -1 ) ;
		do {
// 			ZPixel *zp = &zbuf_y[y][x];
// 			if(z < *zp) {
// 				*zp = z;

				frame_y[y][x]

// 					= cmap->match(c);
 					= pix;
// 			}
// 			++z;
			++x; y += yinc;
// 			++c;
		} while(y != y2);
	} else {
// 		ZPixel *zp = &zbuf_y[y1][x1];
// 		if(z1 < *zp || z2 < *zp) {
// 			if(z1 < z2)
// 				*zp = z1;	
// 			else
// 				*zp = z2;
			set_mask(1 << (x1&3));
// 			frame_y[y1][x1/4] = cmap->match(c1);
// 		frame_y[y1][x1/4] = cmap->match(c);
 			frame_y[y1][x1/4] = pix;
// 		}
	}	
}



 
