// genrawline.C
//	raw line drawing functions for sr3d



#define abs(x)	(((x) >= 0) ? (x) : -(x))
#define sign(x)	(((x) > 0) ? 1 : -1 )


#ifdef INLINE_RAWLINE
#define __INLINE__ inline
#else
#define __INLINE__
#endif


#define DRAWMODE_ZBUF
#define DRAWMODE_DITHER
#define DRAWMODE_GOURAD
#include "linefunc.C"		// zbuf, dither, gourad
#undef DRAWMODE_ZBUF
#include "linefunc.C"		// dither, gourad
#undef DRAWMODE_GOURAD
#include "linefunc.C"		// dither
#define DRAWMODE_ZBUF
#include "linefunc.C"		// zbuf, dither
#undef DRAWMODE_DITHER
#include "linefunc.C"		// zbuf
#undef DRAWMODE_ZBUF
#include "linefunc.C"		// none

 
